%define _disable_ld_no_undefined 1

%{?!maxmodules:%global maxmodules 128}
%{?!serverlimit:%global serverlimit 1024}

%define build_test 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_test: %{expand: %%global build_test 1}}
%{?_without_test: %{expand: %%global build_test 0}}

%define TAG %_vendor

Summary:    The most widely used Web server on the Internet
Name:       apache
Version:    2.2.24
%define subrel 1
Release:    %mkrel 1
Group:      System/Servers
License:    Apache License
URL:        http://httpd.apache.org
Source0:    http://archive.apache.org/dist/httpd/httpd-%{version}.tar.bz2
Source1:    http://archive.apache.org/dist/httpd/httpd-%{version}.tar.bz2.asc
Source3:    apache2_transparent_png_icons.tar.bz2
Source4:    perl-framework.tar.gz
Source9:    htcacheclean.init
Source10:   htcacheclean.sysconfig
Source14:   httpd.tmpfiles
# (cg) Note: the httpd.service mentions all mpms built to ensure appropriate
# conflicts.  Each mpm package gets its own copy of the systemd unit file,
# referring to its own httpd binary.  The mpm packages install a symlink to
# their systemd unit file called httpd.service, and thus only one can be
# enabled at any given time and the user can still refer to the active service
# as httpd.service.  This allows smooth migration from sysvinit to systemd.
Source15:   httpd.service
Source30:   30_mod_proxy.conf
Source31:   31_mod_proxy_ajp.conf
Source32:   32_mod_proxy_scgi.conf
Source40:   40_mod_ssl.conf
Source41:   01_default_ssl_vhost.conf
Source45:   45_mod_dav.conf
Source46:   46_mod_ldap.conf
Source47:   47_mod_authnz_ldap.conf
Source55:   55_mod_cache.conf
Source56:   56_mod_disk_cache.conf
Source57:   57_mod_mem_cache.conf
Source58:   58_mod_file_cache.conf
Source59:   59_mod_deflate.conf
Source60:   60_mod_dbd.conf
Source61:   61_mod_authn_dbd.conf
Source67:   67_mod_userdir.conf
Source68:   68_mod_reqtimeout.conf
Source69:   69_mod_suexec.conf
Source70:   00_manual.conf
Source100:  buildconf
# lynx -dump http://mpm-itk.sesse.net/ > README.itk
Source101:  README.itk
Source102:  README.peruser
Source200:	httpd.init
Source201:	httpd.sysconf
Source202:	httpd.conf
Source203:	fileprotector.conf
Source204:	magic
Source205:	mime.types
Source208:	00_default_vhosts.conf
Source209:	apache-2.0.40-testscript.pl
Source210:	webapp.script
Patch0:     httpd-2.0.45-deplibs.patch
Patch1:     httpd-encode.diff
Patch2:     httpd-2.0.40-xfsz.patch
Patch3:     httpd-2.0.48-corelimit.patch
Patch4:     httpd-2.0.48-debuglog.patch
# http://lists.debian.org/debian-apache/2003/11/msg00109.html
Patch5:     httpd-2.0.48-bsd-ipv6-fix.diff
Patch6:     httpd-2.2.14-apachectl_fix.diff
Patch8:     httpd-2.1.10-apxs.patch
Patch9:     httpd-2.1.10-disablemods.patch
Patch10:    httpd-2.2.23-pod.patch
# http://qa.mandriva.com/show_bug.cgi?id=19542
Patch12:    httpd-2.2.20-french_fixes.patch
Patch13:    httpd-2.2.20-authnoprov.patch
Patch14:    httpd-2.2.4-mod_rewrite-fcgi.diff
# http://issues.apache.org/bugzilla/show_bug.cgi?id=32524
Patch15:    httpd-2.2.23-ab_source_address.patch
# speedups by Allen Pulsifer
Patch16:    httpd-2.2.4-fix_extra_htaccess_check.diff
Patch18:    httpd-2.2.10-ldap_auth_now_modular_in-apr-util-dbd-ldap_fix.diff
Patch20:    httpd-2.2.9-suenable.patch

# http://home.samfundet.no/~sesse/mpm-itk/
Patch100:   http://mpm-itk.sesse.net/httpd-2.2.20-mpm-itk-20090414-00.patch
# http://www.peruser.org/
Patch101:   httpd-2.2.20-peruser-0.3.0.patch
Patch102:   apache-2.2.6-mpm_peruser-fix.diff
Patch103:   httpd-2.2.3-peruser-0.3.0-dc3.diff
Patch104:   httpd-2.2.15-peruser-strfmt.diff
Patch105:   httpd-2.2.17-filter.patch
Patch106:   httpd-2.2.x-CVE-2013-1862.diff
Patch107:   httpd-2.2.x-PR54893.diff

Provides:   webserver
Provides:   apache-mod_actions = %{version}
Provides:   apache-mod_alias = %{version}
Provides:   apache-mod_asis = %{version}
Provides:   apache-mod_auth_basic = %{version}
Provides:   apache-mod_auth_digest = %{version}
Provides:   apache-mod_authn_anon = %{version}
Provides:   apache-mod_authn_dbm = %{version}
Provides:   apache-mod_authn_default = %{version}
Provides:   apache-mod_authn_file = %{version}
Provides:   apache-mod_authz_dbm = %{version}
Provides:   apache-mod_authz_default = %{version}
Provides:   apache-mod_authz_groupfile = %{version}
Provides:   apache-mod_authz_host = %{version}
Provides:   apache-mod_authz_owner = %{version}
Provides:   apache-mod_authz_user = %{version}
Provides:   apache-mod_autoindex = %{version}
Provides:   apache-mod_bucketeer = %{version}
Provides:   apache-mod_case_filter = %{version}
Provides:   apache-mod_case_filter_in = %{version}
Provides:   apache-mod_cern_meta = %{version}
Provides:   apache-mod_cgi = %{version}
Provides:   apache-mod_cgid = %{version}
Provides:   apache-mod_charset_lite = %{version}
Provides:   apache-mod_deflate = %{version}
Provides:   apache-mod_dir = %{version}
Provides:   apache-mod_dumpio = %{version}
Provides:   apache-mod_echo = %{version}
Provides:   apache-mod_env = %{version}
Provides:   apache-mod_example = %{version}
Provides:   apache-mod_expires = %{version}
Provides:   apache-mod_ext_filter = %{version}
Provides:   apache-mod_filter = %{version}
Provides:   apache-mod_headers = %{version}
Provides:   apache-mod_ident = %{version}
Provides:   apache-mod_imagemap = %{version}
Provides:   apache-mod_include = %{version}
Provides:   apache-mod_info = %{version}
Provides:   apache-mod_log_config = %{version}
Provides:   apache-mod_log_forensic = %{version}
Provides:   apache-mod_logio = %{version}
Provides:   apache-mod_mime_magic = %{version}
Provides:   apache-mod_mime = %{version}
Provides:   apache-mod_negotiation = %{version}
Provides:   apache-mod_optional_fn_export = %{version}
Provides:   apache-mod_optional_fn_import = %{version}
Provides:   apache-mod_optional_hook_export = %{version}
Provides:   apache-mod_optional_hook_import = %{version}
Provides:   apache-mod_rewrite = %{version}
Provides:   apache-mod_setenvif = %{version}
Provides:   apache-mod_speling = %{version}
Provides:   apache-mod_status = %{version}
Provides:   apache-mod_unique_id = %{version}
Provides:   apache-mod_usertrack = %{version}
Provides:   apache-mod_version = %{version}
Provides:   apache-mod_vhost_alias = %{version}

Obsoletes:  apache-base
Obsoletes:  apache-modules
Obsoletes:  apache-conf

Requires(pre):  webserver-base
Requires:       webserver-base

# (cg) Note that the Requires(post) here is to ensure that an apache-mpm is
# installed when the post script of the main rpm is run.
Requires(post):	 apache-mpm = %{version}-%{release}
Requires:	 apache-mpm = %{version}-%{release}

BuildRequires:  apr-devel >= 1:1.4.5
BuildRequires:  apr-util-devel >= 1.4.1
BuildRequires:  byacc
BuildRequires:  db-devel
BuildRequires:  expat-devel
BuildRequires:  gdbm-devel
BuildRequires:  libsasl-devel
BuildRequires:  libtool >= 1.4.2
BuildRequires:  openldap-devel
BuildRequires:  openssl-devel
BuildRequires:  pcre-devel
BuildRequires:  zlib-devel
BuildRequires:  lynx
BuildRequires:  libcap-devel
%if %{build_test}
BuildRequires:  perl-CGI >= 1:3.11
BuildRequires:  perl-HTML-Parser
BuildRequires:  perl-libwww-perl
BuildRequires:  perl-Tie-IxHash
BuildRequires:  perl-URI
BuildRequires:  perl-BSD-Resource
BuildRequires:  perl-HTTP-DAV
BuildRequires:  perl-doc
BuildRequires:  perl-Crypt-SSLeay
BuildRequires:  perl-XML-DOM
BuildRequires:  perl-XML-Parser
BuildRequires:  openssl
%endif
BuildRequires:  multiarch-utils >= 1.0.3

%description
This package contains the main binary of apache, a powerful, full-featured,
efficient and freely-available Web server. Apache is also the most popular Web
server on the Internet.

This version of apache is fully modular, and many modules are available in
pre-compiled formats, like PHP and mod_auth_external.

The package was built to support a maximum of %{maxmodules} dynamically
loadable modules, and a ServerLimit of %{serverlimit}. You can change these
values at RPM build time by using for example:
--define 'maxmodules 512' --define 'serverlimit 2048' 

%package    mpm-prefork
Summary:    Implements a non-threaded, pre-forking web server (stable)
Group:      System/Servers
Provides:   apache-mpm = %{version}-%{release}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description    mpm-prefork
This Multi-Processing Module (MPM) implements a non-threaded, pre-forking web
server that handles requests in a manner similar to Apache 1.3. It is
appropriate for sites that need to avoid threading for compatibility with
non-thread-safe libraries. It is also the best MPM for isolating each request,
so that a problem with a single request will not affect any other.

This MPM is very self-regulating, so it is rarely necessary to adjust its
configuration directives. Most important is that MaxClients be big enough to
handle as many simultaneous requests as you expect to receive, but small enough
to assure that there is enough physical RAM for all processes.

The package was built to support a maximum of %{maxmodules} dynamically
loadable modules, and a ServerLimit of %{serverlimit}. You can change these
values at RPM build time by using for example:
--define 'maxmodules 512' --define 'serverlimit 2048' 

%package    mpm-worker
Summary:    Implements a hybrid multi-threaded multi-process web server (experimental)
Group:      System/Servers
Provides:   apache-mpm = %{version}-%{release}
Conflicts:  apache-mod_php apache-mod_perl apache-mod_python
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description    mpm-worker
This Multi-Processing Module (MPM) implements a hybrid multi-process
multi-threaded server. By using threads to serve requests, it is able to serve
a large number of requests with less system resources than a process-based
server. Yet it retains much of the stability of a process-based server by
keeping multiple processes available, each with many threads.

The most important directives used to control this MPM are ThreadsPerChild,
which controls the number of threads deployed by each child process and
MaxClients, which controls the maximum total number of threads that may be
launched.

This package contains the main binary of apache, a powerful, full-featured,
efficient and freely-available Web server. Apache is also the most popular Web
server on the Internet.

This version of apache is fully modular, and many modules are available in
pre-compiled formats, like PHP and mod_auth_external.

The package was built to support a maximum of %{maxmodules} dynamically
loadable modules, and a ServerLimit of %{serverlimit}. You can change these
values at RPM build time by using for example:
--define 'maxmodules 512' --define 'serverlimit 2048' 

I M P O R T A N T
-----------------
Note that the worker mpm (this package) requires thread safe modules. This 
package is totally experimental and may not be stable or suitable at any time,
in any way, or for any kind production usage. Be warned. You must manually
add HTTPD="/usr/sbin/httpd-worker" in the /etc/sysconfig/httpd configuration
file to be able to use this MPM.

%package    mpm-event
Summary:    Implements a hybrid multi-threaded multi-process web server (experimental)
Group:      System/Servers
Provides:   apache-mpm = %{version}-%{release}
Conflicts:  apache-mod_php apache-mod_perl apache-mod_python
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description    mpm-event
The event Multi-Processing Module (MPM) is designed to allow more requests to
be served simultaneously by passing off some processing work to supporting
threads, freeing up the main threads to work on new requests. It is based on
the worker MPM, which implements a hybrid multi-process multi-threaded server.
Run-time configuration directives are identical to those provided by worker.

This package contains the main binary of apache, a powerful, full-featured,
efficient and freely-available Web server. Apache is also the most popular Web
server on the Internet.

This version of apache is fully modular, and many modules are available in
pre-compiled formats, like PHP and mod_auth_external.

The package was built to support a maximum of %{maxmodules} dynamically
loadable modules, and a ServerLimit of %{serverlimit}. You can change these
values at RPM build time by using for example:
--define 'maxmodules 512' --define 'serverlimit 2048' 

I M P O R T A N T
-----------------
Note that the worker mpm (this package) requires thread safe modules. This 
package is totally experimental and may not be stable or suitable at any time,
in any way, or for any kind production usage. Be warned. You must manually
add HTTPD="/usr/sbin/httpd-event" in the /etc/sysconfig/httpd configuration
file to be able to use this MPM.

%package    mpm-itk
Summary:    Implements a non-threaded, pre-forking web server (experimental)
Group:      System/Servers
URL:        http://home.samfundet.no/~sesse/mpm-itk/
Provides:   apache-mpm = %{version}-%{release}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description    mpm-itk
apache-mpm-itk (just mpm-itk for short) is an MPM (Multi-Processing Module) for
the Apache 2 web server (which you've probably heard of :-) ). mpm-itk allows
you to run each of your vhost under a separate uid and gid -- in short, the
scripts and configuration files for one vhost no longer have to be readable for
all the other vhosts.

There are already MPMs available that do this, namely the perchild and Metux
MPMs (the latter being based on the former, which is included in the standard
Apache 2 tree). However, both have their sets of problems; for instance, both
are threaded, which can be a problem for many extension modules. Second, AFAIK
both have issues with listening on multiple ports (ie. SSL etc), and I don't
know how well they really perform in practice. (If you only run CGI scripts,
suexec will also probably solve most of your problems.)

mpm-itk is based on the traditional prefork MPM, which means it's non-threaded;
in short, this means you can run non-thread-aware code (like many PHP
extensions) without problems. (On the other hand, you lose out to any
performance benefit you'd get with threads, of course; you'd have to decide for
yourself if that's worth it or not.)

The package was built to support a maximum of %{maxmodules} dynamically
loadable modules, and a ServerLimit of %{serverlimit}. You can change these
values at RPM build time by using for example:
--define 'maxmodules 512' --define 'serverlimit 2048' 

I M P O R T A N T
-----------------
This package is totally experimental and may not be stable or suitable at any
time, in any way, or for any kind production usage. Be warned. You must
manually add HTTPD="/usr/sbin/httpd-itk" in the /etc/sysconfig/httpd
configuration file to be able to use this MPM.

%package    mpm-peruser
Summary:    Implements a hybrid multi-process, multi-threaded web server (experimental)
Group:      System/Servers
URL:        http://www.telana.com/peruser.php
Provides:   apache-mpm = %{version}-%{release}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description    mpm-peruser
This Multi-Processing Module (MPM) implements a hybrid multi-process,
multi-threaded web server. A fixed number of processes create threads to handle
requests. Fluctuations in load are handled by increasing or decreasing the
number of threads in each process.

Peruser is an Apache 2 module based on metuxmpm, a working implementation of
the perchild MPM. The fundamental concept behind all of them is to run each
apache child process as its own user and group, each handling its own set of
virtual hosts. Peruser and recent metuxmpm releases can also chroot() apache
processes. The result is a sane and secure web server environment for your
users, without kludges like PHP's safe_mode.

The package was built to support a maximum of %{maxmodules} dynamically
loadable modules, and a ServerLimit of %{serverlimit}. You can change these
values at RPM build time by using for example:
--define 'maxmodules 512' --define 'serverlimit 2048' 

I M P O R T A N T
-----------------
This package is totally experimental and may not be stable or suitable at any
time, in any way, or for any kind production usage. Be warned. You must
manually add HTTPD="/usr/sbin/httpd-peruser" in the /etc/sysconfig/httpd
configuration file to be able to use this MPM.

%package    mod_dav
Summary:    Distributed Authoring and Versioning (WebDAV)
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Provides:   apache-mod_dav_fs = %{version}
Provides:   apache-mod_dav_lock = %{version}

%description    mod_dav
This module provides class 1 and class 2 WebDAV ('Web-based Distributed
Authoring and Versioning') functionality for Apache.

This extension to the HTTP protocol allows creating, moving, copying, and
deleting resources and collections on a remote web server.

%package    mod_ldap
Summary:    LDAP connection pooling and result caching DSO:s
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires:   apr-util-dbd-ldap
Provides:   apache-mod_authnz_ldap = %{version}
Obsoletes:  apache-mod_auth_ldap

%description    mod_ldap
This module was created to improve the performance of websites relying on
backend connections to LDAP servers. In addition to the functions provided by
the standard LDAP libraries, this module adds an LDAP connection pool and an
LDAP shared memory cache.

%package    mod_cache
Summary:    Content cache keyed to URIs
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}

%description    mod_cache
mod_cache implements an RFC 2616 compliant HTTP content cache that can be used
to cache either local or proxied content. mod_cache requires the services of
one or more storage management modules.

Two storage management modules are included in the base Apache distribution:

 * mod_disk_cache - implements a disk based storage manager for
   use with mod_proxy.
 * mod_mem_cache - implements an in-memory based storage manager.

mod_mem_cache can be configured to operate in two modes: caching open file
descriptors or caching objects in heap storage.

mod_mem_cache is most useful when used to cache locally generated content or to
cache backend server content for mod_proxy configured for ProxyPass (aka
reverse proxy)

%package    mod_disk_cache
Summary:    Implements a disk based storage manager
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires:   apache-mod_cache = %{version}-%{release}
Suggests:   apache-htcacheclean = %{version}-%{release}

%description    mod_disk_cache
mod_disk_cache implements a disk based storage manager. It is primarily of use
in conjunction with mod_proxy.

Content is stored in and retrieved from the cache using URI based keys. Content
with access protection is not cached.

%package    mod_mem_cache
Summary:    Implements a memory based storage manager
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires:   apache-mod_cache = %{version}-%{release}

%description    mod_mem_cache
This module requires the service of mod_cache. It acts as a support module for
mod_cache and provides a memory based storage manager. mod_mem_cache can be
configured to operate in two modes: caching open file descriptors or caching
objects in heap storage. mod_mem_cache is most useful when used to cache
locally generated content or to cache backend server content for mod_proxy
configured for ProxyPass (aka reverse proxy).

Content is stored in and retrieved from the cache using URI based keys. Content
with access protection is not cached.

%package    mod_file_cache
Summary:    Caches a static list of files in memory
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}

%description    mod_file_cache
Caching frequently requested files that change very infrequently is a technique
for reducing server load. mod_file_cache provides two techniques for caching
frequently requested static files.

Through configuration directives, you can direct mod_file_cache to either open
then mmap()a file, or to pre-open a file and save the file's open file handle.
Both techniques reduce server load when processing requests for these files by
doing part of the work (specifically, the file I/O) for serving the file when
the server is started rather than during each request.

Notice: You cannot use this for speeding up CGI programs or other files which
are served by special content handlers. It can only be used for regular files
which are usually served by the Apache core content handler.

This module is an extension of and borrows heavily from the mod_mmap_static
module in Apache 1.3.

%package    mod_deflate
Summary:    Compress content before it is delivered to the client
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}

%description    mod_deflate
The mod_deflate module provides the DEFLATE output filter that allows output
from your server to be compressed before being sent to the client over the
network.

%package    mod_proxy
Summary:    HTTP/1.1 proxy/gateway server
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Provides:   apache-mod_proxy_balancer = %{version}
Provides:   apache-mod_proxy_connect = %{version}
Provides:   apache-mod_proxy_ftp = %{version}
Provides:   apache-mod_proxy_http = %{version}

%description    mod_proxy
This module implements a proxy/gateway for Apache. It implements proxying
capability for FTP, CONNECT (for SSL), HTTP/0.9, HTTP/1.0, and HTTP/1.1. The
module can be configured to connect to other proxy modules for these and other
protocols.

%package    mod_proxy_ajp
Summary:    Provides support for the Apache JServ Protocol version 1.3 (AJP13)
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires:   apache-mod_proxy = %{version}-%{release}

%description    mod_proxy_ajp
This module requires the service of mod_proxy. It provides support for the
Apache JServ Protocol version 1.3 (hereafter AJP13). Thus, in order to get the
ability of handling AJP13 protocol, mod_proxy and mod_proxy_ajp have to be
present in the server.

%package    mod_proxy_scgi
Summary:    Provides support for the the SCGI protocol, version 1
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires:   apache-mod_proxy = %{version}-%{release}

%description    mod_proxy_scgi
This module provides support for the SCGI protocol, version 1.

%package    mod_suexec
Summary:    Allows CGI scripts to run as a specified user and Group
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}

%description    mod_suexec
This module, in combination with the suexec support program
allows CGI scripts to run as a specified user and Group.

Normally, when a CGI or SSI program executes, it runs as the
same user who is running the web server.

%package    mod_userdir
Summary:    User-specific directories
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}

%description    mod_userdir
This module allows user-specific directories to be accessed using the
http://example.com/~username/ syntax.

%package    mod_ssl
Summary:    Strong cryptography using the SSL and TLS protocols
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires(post): openssl makedev
Suggests:   memcached

%description    mod_ssl
This module provides SSL v2/v3 and TLS v1 support for the Apache HTTP Server.
It was contributed by Ralf S. Engeschall based on his mod_ssl project and
originally derived from work by Ben Laurie.

This module relies on OpenSSL to provide the cryptography engine.

This module also have native SNI support, please look here for more
information:

 * http://daniel-lange.com/plugin/tag/sni
 * https://sni.velox.ch/

%package    mod_dbd
Summary:    Manages SQL database connections
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires:   apr-util-dbd-ldap
Suggests:   apr-util-dbd-freetds
Suggests:   apr-util-dbd-mysql
Suggests:   apr-util-dbd-odbc
Suggests:   apr-util-dbd-pgsql
Suggests:   apr-util-dbd-sqlite3

%description    mod_dbd
mod_dbd manages SQL database connections using apr_dbd. It provides database
connections on request to modules requiring SQL database functions, and takes
care of managing databases with optimal efficiency and scalability for both
threaded and non-threaded MPMs.

%package    mod_authn_dbd
Summary:    User authentication using an SQL database
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}
Requires:   apache-mod_dbd = %{version}-%{release}

%description    mod_authn_dbd
This module provides authentication front-ends such as mod_auth_digest and
mod_auth_basic to authenticate users by looking up users in SQL tables. Similar
functionality is provided by, for example, mod_authn_file. This module relies
on mod_dbd to specify the backend database driver and connection parameters,
and manage the database connections.

%package    mod_reqtimeout
Summary:    Set timeout and minimum data rate for receiving requests
Group:      System/Servers
# ensure initscript presence
Requires(post): apache
Requires(postun): apache
Requires:   apache = %{version}-%{release}

%description    mod_reqtimeout
This module allows to set timeouts for the reading request and reading body
phases. It is implemented as an input connection filter that sets the socket
timeout so that the total request time does not exceed the timeout value.

mod_reqtimeout can be used to mitigate slowloris type attacks.

%package    htcacheclean
Summary:    Clean up the disk cache (for apache-mod_disk_cache)
Group:      System/Servers
Suggests:   apache-mod_disk_cache = %{version}-%{release}
Suggests:   apache-mod_proxy = %{version}-%{release}
Requires(post):  rpm-helper >= 0.24.8-1
Requires(preun): rpm-helper >= 0.24.8-1

%description    htcacheclean
htcacheclean is used to keep the size of mod_disk_cache's storage within a
certain limit. This tool can run either manually or in daemon mode. When
running in daemon mode, it sleeps in the background and checks the cache
directories at regular intervals for cached content to be removed.

%package    devel
Summary:    Module development tools for the apache web server
Group:      Development/C
Requires:   apr-devel >= 1:1.4.5
Requires:   apr-util-devel >= 1.4.1
Requires:   db-devel
Requires:   expat-devel
Requires:   gdbm-devel
Requires:   libsasl-devel
Requires:   openssl-devel
Requires:   pcre-devel >= 5.0
Requires:   zlib-devel

%description    devel
The apache-devel package contains the source code for the apache Web server and
the APXS binary you'll need to build Dynamic Shared Objects (DSOs) for apache.

If you are installing the apache Web server and you want to be able to compile
or develop additional modules for apache, you'll need to install this package.

%package    source
Summary:    The apache source code, including patches shipped by %_vendor
Group:      System/Servers
BuildArch:  noarch

%description    source
The apache source code, including patches shipped by %_vendor. Use this package
to build your own customized apache if needed.

%package    doc
Summary:	The apache Manual
Group:		System/Servers
BuildArch:  noarch

%description doc
This package contains the apache server documentation in HTML format.

Please view the documentation by starting the apache server and your
favorite web browser and point to this URL: http://localhost/manual

%prep
%setup -q -n httpd-%{version} -a4
%patch0 -p0 -b .deplibs.droplet
%patch1 -p1 -b .encode.droplet
%patch2 -p0 -b .xfsz.droplet
%patch3 -p0 -b .corelimit.droplet
%patch4 -p1 -b .debuglog.droplet
%patch5 -p1 -b .bsd-ipv6.droplet
%patch6 -p0 -b .apachectl_fix.droplet
%patch8 -p1 -b .apxs.droplet
%patch9 -p1 -b .disablemods.droplet
%patch10 -p1 -b .pod.droplet
%patch12 -p1 -b .french_fixes.droplet
%patch13 -p1 -b .authnoprov.droplet
%patch14 -p0 -b .fcgi.droplet
%patch15 -p1 -b .ab_source_address.droplet
%patch16 -p0 -b .fix_extra_htaccess_check.droplet
%patch18 -p0 -b .PR45994.droplet
%patch20 -p1 -b .suenable.droplet

%patch100 -p1 -b .mpm-itk.droplet
%patch101 -p1 -b .mpm-peruser.droplet
%patch102 -p1 -b .mpm_peruser-fix.droplet
%patch103 -p1 -b .peruser-0.3.0-dc3.droplet
%patch104 -p0 -b .peruser-strfmt.droplet
%patch105 -p1 -b .filter
%patch106 -p0 -b .CVE-2013-1862.droplet
%patch107 -p0 -b .PR54893.droplet

# forcibly prevent use of bundled apr, apr-util, pcre
rm -rf srclib/{apr,apr-util,pcre}

# don't install or use bundled pcreposix.h
rm -f include/pcreposix.h

#Fix apxs
perl -pi \
    -e 's|\@exp_installbuilddir\@|%{_libdir}/apache/build|;' \
    -e 's|get_vars\("prefix"\)|"%{_libdir}/apache/build"|;' \
    -e 's|get_vars\("sbindir"\) . "/envvars"|"\$installbuilddir/envvars"|;' \
    support/apxs.in

#Correct perl paths
find -type f -print0 | xargs -0 perl -pi \
    -e 's|/usr/local/bin/perl|perl|g;' \
    -e 's|/usr/local/bin/perl5|perl|g;' \
    -e 's|/path/to/bin/perl|perl|g;'

# this is really better and easier than a stupid static patch...
# for some reason you have to use ">>" here (!)

cat >> config.layout << EOF
<Layout NUX>
    prefix:        %{_sysconfdir}/httpd
    exec_prefix:   %{_prefix}
    bindir:        %{_bindir}
    sbindir:       %{_sbindir}
    libdir:        %{_libdir}
    libexecdir:    %{_libdir}/apache
    mandir:        %{_mandir}
    infodir:       %{_infodir}
    includedir:    %{_includedir}/apache
    sysconfdir:    %{_sysconfdir}/httpd/conf
    datadir:       /var/www
    installbuilddir: %{_libdir}/apache/build
    errordir:      /var/www/error
    iconsdir:      /var/www/icons
    htdocsdir:     /var/www/html
    manualdir:     
    cgidir:        /var/www/cgi-bin
    localstatedir: /var
    runtimedir:    /var/run
    logfiledir:    /var/log/httpd
    proxycachedir: /var/cache/httpd/mod_proxy
</Layout>     
EOF

# bump max modules
perl -pi \
    -e 's/DYNAMIC_MODULE_LIMIT \d+/DYNAMIC_MODULE_LIMIT %{maxmodules}/;' \
    include/httpd.h

# bump server limit
perl -pi \
    -e 's/DEFAULT_SERVER_LIMIT \d+/DEFAULT_SERVER_LIMIT %{serverlimit}/' \
    server/mpm/prefork/prefork.c \
    server/mpm/experimental/itk/itk.c \
    server/mpm/experimental/peruser/peruser.c

# don't try to touch srclib
perl -pi -e "s|^SUBDIRS = .*|SUBDIRS = os server modules support|g" Makefile.in

# prepare the apache-source package
rm -rf %{_builddir}/tmp-httpd-%{version}
mkdir -p %{_builddir}/tmp-httpd-%{version}/usr/src
cp -dpR %{_builddir}/httpd-%{version} %{_builddir}/tmp-httpd-%{version}/usr/src/apache-%{version}
rm -rf %{_builddir}/tmp-httpd-%{version}/usr/src/apache-%{version}/perl-framework
rm -rf %{_builddir}/tmp-httpd-%{version}/usr/src/apache-%{version}/tmp-httpd-%{version}/usr/src
rm -f %{_builddir}/tmp-httpd-%{version}%{_usrsrc}/apache-%{version}/*.spec

# use my nice converted transparent png icons
tar -jxf %{SOURCE3}
mv icons/*.png docs/icons/

# this will only work if configured correctly in the config (FullOs)...
cp server/core.c server/core.c.untagged

cp %{SOURCE101} README.itk
cp %{SOURCE102} README.peruser

cp %{SOURCE70} 00_manual.conf
perl -pi -e "s|_DOCDIR_|%{_docdir}/%{name}-doc|g" 00_manual.conf

%build
%serverbuild

#########################################################################################
# configure and build phase
#
# use a minimal buildconf instead
cp %{SOURCE100} buildconf
sh ./buildconf

CFLAGS="`echo $RPM_OPT_FLAGS |sed -e 's/-fomit-frame-pointer//'`"
CPPFLAGS="-DSSL_EXPERIMENTAL_ENGINE -DLDAP_DEPRECATED"
if pkg-config openssl; then
    # configure -C barfs with trailing spaces in CFLAGS
    CFLAGS="$RPM_OPT_FLAGS $CPPFLAGS"
    CPPFLAGS="$CPPFLAGS `pkg-config --cflags openssl | sed 's/ *$//'`"
    AP_LIBS="$AP_LIBS `pkg-config --libs openssl`"
else
    CFLAGS="$RPM_OPT_FLAGS"
    CPPFLAGS="$CPPFLAGS"
    AP_LIBS="$AP_LIBS -lssl -lcrypto"
fi
export CFLAGS CPPFLAGS AP_LIBS

export SH_LDFLAGS="%{ldflags}"

APVARS="--enable-layout=NUX \
    --prefix=%{_sysconfdir}/httpd \
    --exec-prefix=%{_prefix} \
    --bindir=%{_bindir} \
    --sbindir=%{_sbindir} \
    --libexecdir=%{_libdir}/apache \
    --sysconfdir=%{_sysconfdir}/httpd/conf \
    --localstatedir=/var \
    --includedir=%{_includedir}/apache \
    --infodir=%{_infodir} \
    --mandir=%{_mandir} \
    --datadir=/var/www \
    --with-port=80 \
    --with-perl=%{_bindir}/perl \
    --with-apr=%{_bindir}/apr-1-config \
    --with-apr-util=%{_bindir}/apu-1-config \
    --with-pcre=%{_prefix} \
    --with-z=%{_prefix} \
    --enable-layout=NUX \
    --with-devrandom \
    --enable-exception-hook \
    --enable-forward \
    --with-program-name=httpd \
    --with-suexec-caller=apache \
    --with-suexec-userdir=public_html \
    --with-suexec-docroot=%{_var}/www \
    --with-suexec-uidmin=100 \
    --with-suexec-gidmin=100 \
    --with-suexec-logfile=%{_var}/log/httpd/suexec_log \
    --with-suexec-safepath=/usr/local/bin:/usr/bin:/bin \
    --with-suexec-bin=%{_sbindir}/suexec \
    --with-suexec-umask=077"

for mpm in worker event itk peruser prefork; do
    mkdir build-${mpm}; pushd build-${mpm}
    ln -s ../configure .
    
    if [ ${mpm} = prefork ]; then
        %configure2_5x $APVARS \
            --with-mpm=prefork \
            --enable-modules=all \
            --enable-mods-shared=all \
            --with-ldap \
            --enable-ldap=shared \
            --enable-authnz-ldap=shared \
            --enable-cache=shared \
            --enable-disk-cache=shared \
            --enable-file-cache=shared \
            --enable-mem-cache=shared \
            --enable-ssl \
            --with-ssl=%{_prefix} \
            --disable-distcache \
            --enable-deflate=shared \
            --enable-cgid=shared \
            --enable-proxy=shared \
            --enable-proxy-connect=shared \
            --enable-proxy-ftp=shared \
            --enable-proxy-http=shared \
            --enable-proxy-ajp=shared \
            --enable-proxy-balancer=shared \
            --enable-dav=shared \
            --enable-dav-fs=shared \
            --enable-dav-lock=shared \
            --enable-version=shared \
            --enable-bucketeer=shared \
            --enable-case-filter=shared \
            --enable-case-filter-in=shared \
            --enable-echo=shared \
            --enable-example=shared \
            --enable-optional-fn-export=shared \
            --enable-optional-fn-import=shared \
            --enable-optional-hook-export=shared \
            --enable-optional-hook-import=shared \
            --enable-charset_lite=shared \
            --enable-authn_alias=shared \
            --enable-suexec=shared
    fi
    
    if [ ${mpm} = worker ]; then
        %configure2_5x $APVARS \
            --with-mpm=worker \
            --enable-modules=none
        # don't build support tools
        perl -pi -e "s|^SUBDIRS = .*|SUBDIRS = os server modules|g" Makefile
    fi

    if [ ${mpm} = event ]; then
        %configure2_5x $APVARS \
            --with-mpm=event \
            --enable-modules=none
        # don't build support tools
        perl -pi -e "s|^SUBDIRS = .*|SUBDIRS = os server modules|g" Makefile
    fi

    if [ ${mpm} = itk ]; then
        %configure2_5x $APVARS \
            --with-mpm=itk \
            --enable-modules=none
        # don't build support tools
        perl -pi -e "s|^SUBDIRS = .*|SUBDIRS = os server modules|g" Makefile
    fi

    if [ ${mpm} = peruser ]; then
        %configure2_5x $APVARS \
            --with-mpm=peruser \
            --enable-modules=none
        # don't build support tools
        perl -pi -e "s|^SUBDIRS = .*|SUBDIRS = os server modules|g" Makefile
    fi

    #Copy configure flags to a file in the apache-source rpm.
    cp config.nice %{_builddir}/tmp-httpd-%{version}%{_usrsrc}/apache-%{version}/config.nice.${mpm}

    # tag it with the mpm name too so that we can track this somehow at for example netcraft...
    MPM_NAME=`echo ${mpm}|tr "[a-z]" "[A-Z]"`
    cp ../server/core.c.untagged ../server/core.c
    perl -pi -e "s|\" PLATFORM \"|%{TAG}/${MPM_NAME}-%{release}|g" ../server/core.c

    # if libexpat0-devel is installed on x86_64 somehow the EXTRA_LDLAGS is set 
    # to -L/usr/lib, fix that with a conditional hack...
    %ifarch x86_64
    find -type f | xargs perl -pi -e "s|/usr/lib\b|%{_libdir}|g"
    %endif

    # Build the systemd file
    sed "s,@NAME@,${mpm},g;s,@EXEC@,%{_sbindir}/httpd-${mpm},g;s,httpd-${mpm}\.service,,g" %{SOURCE15} > httpd.service
    touch -r %{SOURCE15} httpd.service

    # finally doing the build stage
    %make
    popd
done

# (cg) Fix the binary name in the prefork unit
sed -i "s,httpd-prefork,httpd,g" build-prefork/httpd.service

%if %{build_test}
# run the test suite, quite a hack, but works, sometimes...
TEST_DIR="`pwd`/TEST"
make -C build-prefork DESTDIR=${TEST_DIR} \
    manualdir=${TEST_DIR}/var/www/html/manual \
    install

perl -pi -e "s|%{_libdir}/apache/|${TEST_DIR}%{_libdir}/apache/|g" ${TEST_DIR}%{_sysconfdir}/httpd/conf/*
perl -pi -e "s|^#Include|Include|g" ${TEST_DIR}%{_sysconfdir}/httpd/conf/httpd.conf
perl -pi -e "s|/etc|${TEST_DIR}/etc|g" ${TEST_DIR}%{_sysconfdir}/httpd/conf/httpd.conf ${TEST_DIR}%{_sysconfdir}/httpd/conf/extra/*.conf
perl -pi -e  "s|%{_libdir}/apache/build|${TEST_DIR}%{_libdir}/apache/build|g" ${TEST_DIR}%{_sbindir}/apxs

# fool apxs
cat >> ${TEST_DIR}%{_libdir}/apache/build/config_vars.mk << EOF
bindir = ${TEST_DIR}/usr/bin
sbindir = ${TEST_DIR}/usr/sbin
exec_prefix = ${TEST_DIR}/usr
datadir = ${TEST_DIR}/var/www
localstatedir = ${TEST_DIR}/var
libdir = ${TEST_DIR}%{_libdir}
libexecdir = ${TEST_DIR}%{_libdir}/apache
includedir = ${TEST_DIR}/usr/include/apache
sysconfdir = ${TEST_DIR}/etc/httpd/conf
installbuilddir = ${TEST_DIR}%{_libdir}/apache/build
runtimedir = ${TEST_DIR}/var/run
proxycachedir = ${TEST_DIR}/var/cache/httpd/mod_proxy
prefix = ${TEST_DIR}/usr
EOF

pushd perl-framework

# disable test cases for bugs that has not been fixed yet,are too old, or
# it is unclear who to blaim, either the php or ASF folks...
rm -f t/php/arg.t
rm -f t/php/func5.t

# this test works with php-5.0 but not with php-5.1, yuck!
rm -f t/php/virtual.t

# if not using LC_ALL=C t/php/getlastmod.t can fail at
# testing : getlastmod()
# expected: november
# received: November
export LC_ALL=C

perl Makefile.PL -apxs ${TEST_DIR}%{_sbindir}/apxs \
    -httpd_conf ${TEST_DIR}%{_sysconfdir}/httpd/conf/httpd.conf \
    -httpd ${TEST_DIR}%{_sbindir}/httpd
make test
popd
%endif

%install
rm -rf %{buildroot} 
#########################################################################################
# install phase
install -d %{buildroot}%{_libdir}/apache
install -d %{buildroot}%{_libdir}/apache-extramodules
install -d %{buildroot}%{_sysconfdir}/httpd/conf
install -d %{buildroot}%{_sysconfdir}/httpd/conf/vhosts.d
install -d %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
install -d %{buildroot}%{_sysconfdir}/httpd/conf.d
install -d %{buildroot}%{_sysconfdir}/httpd/modules.d
install -d %{buildroot}/var/lib/dav
install -d %{buildroot}/var/log/httpd
install -d %{buildroot}/var/www
install -d %{buildroot}/var/www/html
install -d %{buildroot}/var/www/perl
install -d %{buildroot}/var/www/cgi-bin
install -d %{buildroot}/var/cache/httpd/mod_proxy

# install source
tar c -C %{_builddir}/tmp-httpd-%{version} usr/src | tar x -C %{buildroot}


pushd build-prefork
make install \
    prefix=%{buildroot}%{_prefix} \
    bindir=%{buildroot}%{_bindir} \
    sbindir=%{buildroot}%{_sbindir} \
    libdir=%{buildroot}%{_libdir} \
    libexecdir=%{buildroot}%{_libdir}/apache \
    mandir=%{buildroot}%{_mandir} \
    sysconfdir=%{buildroot}%{_sysconfdir}/httpd/conf \
    includedir=%{buildroot}%{_includedir}/apache \
    localstatedir=%{buildroot}/var \
    runtimedir=%{buildroot}/var/run \
    installbuilddir=%{buildroot}%{_libdir}/apache/build  \
    datadir=%{buildroot}/var/www \
    errordir=%{buildroot}/var/www/error \
    iconsdir=%{buildroot}/var/www/icons \
    htdocsdir=%{buildroot}/var/www/html \
    manualdir=%{buildroot}/var/www/html/manual \
    cgidir=%{buildroot}/var/www/cgi-bin \
    runtimedir=%{buildroot}/var/run \
    logdir=%{buildroot}/var/log/httpd \
    logfiledir=%{buildroot}/var/log/httpd \
    proxycachedir=%{buildroot}/var/cache/httpd/mod_proxy
popd


# this is needed to generate the vanilla config
make -C build-prefork DESTDIR=`pwd` install-conf

#Fix config_vars.mk, and add some MDK flags so all other modules 
#can simply do "apxs -q VARIABLE" and know, for example, the exact
#release of apache-devel or the exact directory where the source is
#located. 
CVMK="%{buildroot}%{_libdir}/apache/build/config_vars.mk"
perl -pi \
    -e "s|%{_builddir}/httpd-%{version}|%{_usrsrc}/apache-%{version}|g;" \
    -e "s|%{buildroot}||g;" \
    -e "s|^EXTRA_INCLUDES.*|EXTRA_INCLUDES = `apr-1-config --includes` -I%{_includedir}/apache -I%{_includedir}/openssl|g;" \
     $CVMK

# fix libtool invocation
perl -pi \
    -e "s|^LIBTOOL.*|LIBTOOL = libtool|g;" \
    -e "s|^SH_LIBTOOL.*|SH_LIBTOOL = libtool|g;" \
    $CVMK

echo "ap_version = %{version}" >> $CVMK
echo "ap_release = %{release}" >> $CVMK

#########################################################################################
# fix some bugs and other stuff
#
perl -pi -e "s|%{_builddir}/httpd-%{version}|%{_usrsrc}/apache-%{version}|g" %{buildroot}%{_libdir}/apache/build/apr_rules.mk

mv %{buildroot}%{_sbindir}/envvars %{buildroot}%{_libdir}/apache/build/

# named config.nice files are in the devel package
rm -f %{buildroot}%{_libdir}/apache/build/config.nice

##################################################################

# Link build dir
ln -s ../../..%{_libdir}/apache/build %{buildroot}%{_sysconfdir}/httpd/build

##################################################################
# install module conf files for the "modules.d" dir loading structure
install -m0644 %{SOURCE30} %{buildroot}%{_sysconfdir}/httpd/modules.d/30_mod_proxy.conf 
install -m0644 %{SOURCE31} %{buildroot}%{_sysconfdir}/httpd/modules.d/31_mod_proxy_ajp.conf
install -m0644 %{SOURCE32} %{buildroot}%{_sysconfdir}/httpd/modules.d/32_mod_proxy_scgi.conf
install -m0644 %{SOURCE40} %{buildroot}%{_sysconfdir}/httpd/modules.d/40_mod_ssl.conf
install -m0644 %{SOURCE45} %{buildroot}%{_sysconfdir}/httpd/modules.d/45_mod_dav.conf
install -m0644 %{SOURCE46} %{buildroot}%{_sysconfdir}/httpd/modules.d/46_mod_ldap.conf
install -m0644 %{SOURCE47} %{buildroot}%{_sysconfdir}/httpd/modules.d/47_mod_authnz_ldap.conf
install -m0644 %{SOURCE55} %{buildroot}%{_sysconfdir}/httpd/modules.d/55_mod_cache.conf
install -m0644 %{SOURCE56} %{buildroot}%{_sysconfdir}/httpd/modules.d/56_mod_disk_cache.conf
install -m0644 %{SOURCE57} %{buildroot}%{_sysconfdir}/httpd/modules.d/57_mod_mem_cache.conf

install -m0644 %{SOURCE58} %{buildroot}%{_sysconfdir}/httpd/modules.d/58_mod_file_cache.conf
install -m0644 %{SOURCE59} %{buildroot}%{_sysconfdir}/httpd/modules.d/59_mod_deflate.conf
install -m0644 %{SOURCE60} %{buildroot}%{_sysconfdir}/httpd/modules.d/60_mod_dbd.conf
install -m0644 %{SOURCE61} %{buildroot}%{_sysconfdir}/httpd/modules.d/61_mod_authn_dbd.conf
install -m0644 %{SOURCE67} %{buildroot}%{_sysconfdir}/httpd/modules.d/67_mod_userdir.conf
install -m0644 %{SOURCE68} %{buildroot}%{_sysconfdir}/httpd/modules.d/68_mod_reqtimeout.conf
install -m0644 %{SOURCE69} %{buildroot}%{_sysconfdir}/httpd/modules.d/69_mod_suexec.conf

# install vhost conf files for the "vhosts.d" dir loading structure
install -m0644 %{SOURCE41} %{buildroot}%{_sysconfdir}/httpd/conf/vhosts.d/

# install the mpm stuff
install -m0755 build-worker/httpd %{buildroot}%{_sbindir}/httpd-worker
install -m0755 build-event/httpd %{buildroot}%{_sbindir}/httpd-event
install -m0755 build-itk/httpd %{buildroot}%{_sbindir}/httpd-itk
install -m0755 build-peruser/httpd %{buildroot}%{_sbindir}/httpd-peruser

# install missing files
install -m755 build-prefork/support/split-logfile %{buildroot}%{_sbindir}/split-logfile
install -m755 support/list_hooks.pl %{buildroot}%{_sbindir}/list_hooks.pl
install -m755 build-prefork/support/logresolve.pl %{buildroot}%{_sbindir}/logresolve.pl
install -m755 build-prefork/support/log_server_status %{buildroot}%{_sbindir}/log_server_status
install -m755 build-prefork/support/checkgid %{buildroot}%{_sbindir}/checkgid
install -m755 support/check_forensic %{buildroot}%{_sbindir}/check_forensic

# fix a msec safe cache for the ssl stuff
install -d %{buildroot}/var/cache/httpd/mod_ssl
touch %{buildroot}/var/cache/httpd/mod_ssl/scache.dir
touch %{buildroot}/var/cache/httpd/mod_ssl/scache.pag
touch %{buildroot}/var/cache/httpd/mod_ssl/scache.sem

# fix a msec safe cache for the mod_ldap LDAPSharedCacheFile
touch %{buildroot}/var/cache/httpd/mod_ldap_cache

# install htcacheclean files
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/sysconfig
install -m0755 %{SOURCE9} %{buildroot}%{_initrddir}/htcacheclean
install -m0644 %{SOURCE10} %{buildroot}%{_sysconfdir}/sysconfig/htcacheclean

# systemd files
install -d -m 755 %{buildroot}%{_unitdir}
for mpm in worker event itk peruser prefork; do
  install -m 644 build-${mpm}/httpd.service \
      %{buildroot}%{_unitdir}/httpd-${mpm}.service
done

install -d -m 755 %{buildroot}%{_sysconfdir}/tmpfiles.d 
install -m 644 %{SOURCE14} %{buildroot}%{_sysconfdir}/tmpfiles.d/httpd.conf

%multiarch_includes %{buildroot}%{_includedir}/apache/ap_config_layout.h

# install documentation
lynx -dump -nolist -stdin < docs/manual/new_features_2_2.html.en \
    > new_features_2_2.txt
lynx -dump -nolist -stdin < docs/manual/upgrading.html.en \
    > upgrading.txt

# fix the manual
rm -rf installed-manual
mv %{buildroot}/var/www/html/manual installed-manual
find installed-manual -type d -exec chmod 755 {} \;
find installed-manual -type f -exec chmod 644 {} \;
install -d %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
install -m0644 00_manual.conf %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/00_manual.conf

# cleanup
rm -rf %{buildroot}/var/www/html/index*
rm -rf %{buildroot}/var/www/html/apach*
rm -rf %{buildroot}/var/www/cgi-bin/printenv
rm -rf %{buildroot}/var/www/cgi-bin/test-cgi
rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/{extra,original}
find %{buildroot} -type f -name "*.orig" | xargs rm -f
find %{buildroot} -type f -name "*.droplet" | xargs rm -f

install -m0755 %{SOURCE209} %{buildroot}/var/www/cgi-bin/test.cgi
install -m0755 %{SOURCE209} %{buildroot}/var/www/perl/test.pl
install -m0755 %{SOURCE200} %{buildroot}%{_initrddir}/httpd

# make some dangling soft links 
pushd %{buildroot}%{_sysconfdir}/httpd
    ln -s ../../usr/%{_lib} %{_lib}
    ln -s ../../var/log/httpd logs
    ln -s ../../usr/%{_lib}/apache modules
    ln -s ../../usr/%{_lib}/apache-extramodules extramodules
popd

# config files
install -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
install -m0644 %{SOURCE201} %{buildroot}%{_sysconfdir}/sysconfig/httpd

install -m0644 %{SOURCE202} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
install -m0644 %{SOURCE203} %{buildroot}%{_sysconfdir}/httpd/conf/fileprotector.conf
install -m0644 %{SOURCE205} %{buildroot}%{_sysconfdir}/httpd/conf/mime.types
install -m0644 %{SOURCE204} %{buildroot}%{_sysconfdir}/httpd/conf/magic
install -m0644 %{SOURCE208} %{buildroot}%{_sysconfdir}/httpd/conf/vhosts.d/00_default_vhosts.conf

# install log rotation stuff
install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/httpd << EOF
/var/log/httpd/*_log /var/log/httpd/apache_runtime_status /var/log/httpd/ssl_mutex {
    rotate 5
    monthly
    missingok
    notifempty
    nocompress
    prerotate
	%{_initrddir}/httpd closelogs > /dev/null 2>&1 || :
    endscript
    postrotate
	%{_initrddir}/httpd closelogs > /dev/null 2>&1 || :
    endscript
}
EOF

# rpm filetriggers
install -d -m 755 %{buildroot}%{_localstatedir}/lib/rpm/filetriggers
cat > %{buildroot}%{_localstatedir}/lib/rpm/filetriggers/webapp.filter << EOF
^./etc/httpd/conf/webapps.d/.*\.conf$
EOF
install -m 755 %{SOURCE210} \
    %{buildroot}%{_localstatedir}/lib/rpm/filetriggers/webapp.script

cat > %{buildroot}%{_localstatedir}/lib/rpm/filetriggers/httpd.filter << EOF
^.%{_libdir}/apache.*/mod_.*\.so$
EOF
cat > %{buildroot}%{_localstatedir}/lib/rpm/filetriggers/httpd.script << EOF
#!/bin/sh
service httpd condrestart 2>/dev/null || :
EOF

%clean
rm -rf %{_builddir}/tmp-httpd-%{version}

# (dw) mpm packages don't automatically cause a restart, because on upgrade
# there will already be 2 restarts due to the main package and the modules, and
# if you want to run an mpm other than prefork, that has to be configured
# manually (via systemctl for systemd or sysconfig for sysvinit), so automatic
# restart is not appropriate.  Apache modules cause a restart via filetriggers,
# so that a restart can be done for modules, but only once, even if some of the
# modules are coming from other SRPMS.  Also, filetriggers are run right before
# posttrans, and this is important because on Apache version upgrades, the mpm
# needs to be upgraded before a restart because the modules may be dependent on
# new symbols in httpd.

%post
%_post_service httpd

%preun
%_preun_service httpd

# (cg) In the various mpm packages, we ensure the symlink httpd.service exists
# as this will allow smooth migration from the sysvinit service to a native
# systemd service due to the migration code in rpm-helper following the
# httpd.service symlink through to the actual mpm unit name.
# If the symlink already exists, we just leave it alone!

%post mpm-prefork
ln -s %{_unitdir}/httpd-prefork.service %{_sysconfdir}/systemd/system/httpd.service 2>/dev/null || :

%post mpm-worker
ln -s %{_unitdir}/httpd-worker.service %{_sysconfdir}/systemd/system/httpd.service 2>/dev/null || :

%post mpm-event
ln -s %{_unitdir}/httpd-event.service %{_sysconfdir}/systemd/system/httpd.service 2>/dev/null || :

%post mpm-itk
ln -s %{_unitdir}/httpd-itk.service %{_sysconfdir}/systemd/system/httpd.service 2>/dev/null || :

%post mpm-peruser
ln -s %{_unitdir}/httpd-peruser.service %{_sysconfdir}/systemd/system/httpd.service 2>/dev/null || :

%post mod_ldap
%create_ghostfile /var/cache/httpd/mod_ldap_cache apache root 0600

%post mod_ssl
if [ "$1" = "1" ]; then 

mkdir -p %{_sysconfdir}/pki/tls/{private,certs} 2>/dev/null || :
umask 077

if [ ! -f %{_sysconfdir}/pki/tls/private/localhost.key ]; then
    %{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{_sysconfdir}/pki/tls/private/localhost.key 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
    FQDN=localhost.localdomain
fi

if [ ! -f %{_sysconfdir}/pki/tls/certs/localhost.crt ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{_sysconfdir}/pki/tls/private/localhost.key -x509 -days 365 -set_serial $RANDOM -out %{_sysconfdir}/pki/tls/certs/localhost.crt 2>/dev/null || :
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi
fi

if [ "$1" -gt "1" ]; then
    mkdir -p %{_sysconfdir}/pki/tls/{private,certs} 2>/dev/null || :
    if [ -d /etc/ssl/apache ];then
    if [ -f /etc/ssl/apache/server.crt.rpmsave -a ! -f /etc/pki/tls/certs/localhost.crt ]; then
        cp -p /etc/ssl/apache/server.crt.rpmsave /etc/pki/tls/certs/localhost.crt
    fi
    if [ -f /etc/ssl/apache/server.key.rpmsave -a ! -f /etc/pki/tls/private/localhost.key ]; then
        cp -p /etc/ssl/apache/server.key.rpmsave /etc/pki/tls/private/localhost.key
    fi

    fi
fi

# create some ghost files
%create_ghostfile /var/cache/httpd/mod_ssl/scache.dir apache root 0600
%create_ghostfile /var/cache/httpd/mod_ssl/scache.pag apache root 0600
%create_ghostfile /var/cache/httpd/mod_ssl/scache.sem apache root 0600

# http://qa.mandriva.com/show_bug.cgi?id=33429
if [ -f /etc/pki/tls/certs/localhost.crt ]; then
    chmod 644 /etc/pki/tls/certs/localhost.crt
fi

%post htcacheclean
%_post_service htcacheclean

%preun htcacheclean
%_preun_service htcacheclean

%files mpm-prefork
%{_sbindir}/httpd
%{_unitdir}/httpd-prefork.service

%files mpm-worker
%{_sbindir}/httpd-worker
%{_unitdir}/httpd-worker.service

%files mpm-event
%{_sbindir}/httpd-event
%{_unitdir}/httpd-event.service

%files mpm-itk
%doc README.itk
%{_sbindir}/httpd-itk
%{_unitdir}/httpd-itk.service

%files mpm-peruser
%doc server/mpm/experimental/peruser/AUTHORS README.peruser
%{_sbindir}/httpd-peruser
%{_unitdir}/httpd-peruser.service

%files
%doc upgrading.txt new_features_2_2.txt
%doc ABOUT_APACHE CHANGES INSTALL LAYOUT NOTICE README* ROADMAP VERSIONING

%{_initrddir}/httpd

%config(noreplace) %{_sysconfdir}/sysconfig/httpd
%config(noreplace) %{_sysconfdir}/tmpfiles.d/httpd.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/httpd
%dir %{_sysconfdir}/httpd
%dir %{_sysconfdir}/httpd/conf
%dir %{_sysconfdir}/httpd/conf/webapps.d
%dir %{_sysconfdir}/httpd/conf/vhosts.d
%dir %{_sysconfdir}/httpd/conf.d
%dir %{_sysconfdir}/httpd/modules.d
%dir %{_sysconfdir}/httpd/%{_lib}
%dir %{_sysconfdir}/httpd/logs
%dir %{_sysconfdir}/httpd/modules
%dir %{_sysconfdir}/httpd/extramodules
%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/fileprotector.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/mime.types
%config(noreplace) %{_sysconfdir}/httpd/conf/magic
%config(noreplace) %{_sysconfdir}/httpd/conf/vhosts.d/00_default_vhosts.conf

%dir /var/www/error
%dir /var/www/error/include
%config(noreplace,missingok) /var/www/error/README
%config(noreplace,missingok) /var/www/error/*.var
%config(noreplace,missingok) /var/www/error/include/*.html
/var/www/cgi-bin
/var/www/icons
/var/www/perl

%{_sbindir}/ab
%{_sbindir}/apachectl
%{_sbindir}/check_forensic
%{_sbindir}/checkgid
%{_sbindir}/dbmmanage
%{_sbindir}/htdbm
%{_sbindir}/htdigest
%{_sbindir}/htpasswd
%{_sbindir}/httxt2dbm
%{_sbindir}/list_hooks.pl
%{_sbindir}/logresolve
%{_sbindir}/logresolve.pl
%{_sbindir}/log_server_status
%{_sbindir}/rotatelogs
%{_sbindir}/split-logfile

%{_libdir}/apache/mod_actions.so
%{_libdir}/apache/mod_alias.so
%{_libdir}/apache/mod_asis.so
%{_libdir}/apache/mod_auth_basic.so
%{_libdir}/apache/mod_auth_digest.so
%{_libdir}/apache/mod_authn_alias.so
%{_libdir}/apache/mod_authn_anon.so
%{_libdir}/apache/mod_authn_dbm.so
%{_libdir}/apache/mod_authn_default.so
%{_libdir}/apache/mod_authn_file.so
%{_libdir}/apache/mod_authz_dbm.so
%{_libdir}/apache/mod_authz_default.so
%{_libdir}/apache/mod_authz_groupfile.so
%{_libdir}/apache/mod_authz_host.so
%{_libdir}/apache/mod_authz_owner.so
%{_libdir}/apache/mod_authz_user.so
%{_libdir}/apache/mod_autoindex.so
%{_libdir}/apache/mod_bucketeer.so
%{_libdir}/apache/mod_case_filter_in.so
%{_libdir}/apache/mod_case_filter.so
%{_libdir}/apache/mod_cern_meta.so
%{_libdir}/apache/mod_cgid.so
%{_libdir}/apache/mod_cgi.so
%{_libdir}/apache/mod_charset_lite.so
%{_libdir}/apache/mod_dir.so
%{_libdir}/apache/mod_dumpio.so
%{_libdir}/apache/mod_echo.so
%{_libdir}/apache/mod_env.so
%{_libdir}/apache/mod_example.so
%{_libdir}/apache/mod_expires.so
%{_libdir}/apache/mod_ext_filter.so
%{_libdir}/apache/mod_filter.so
%{_libdir}/apache/mod_headers.so
%{_libdir}/apache/mod_ident.so
%{_libdir}/apache/mod_imagemap.so
%{_libdir}/apache/mod_include.so
%{_libdir}/apache/mod_info.so
%{_libdir}/apache/mod_log_config.so
%{_libdir}/apache/mod_log_forensic.so
%{_libdir}/apache/mod_logio.so
%{_libdir}/apache/mod_mime_magic.so
%{_libdir}/apache/mod_mime.so
%{_libdir}/apache/mod_negotiation.so
%{_libdir}/apache/mod_optional_fn_export.so
%{_libdir}/apache/mod_optional_fn_import.so
%{_libdir}/apache/mod_optional_hook_export.so
%{_libdir}/apache/mod_optional_hook_import.so
%{_libdir}/apache/mod_rewrite.so
%{_libdir}/apache/mod_setenvif.so
%{_libdir}/apache/mod_speling.so
%{_libdir}/apache/mod_status.so
%{_libdir}/apache/mod_substitute.so
%{_libdir}/apache/mod_unique_id.so
%{_libdir}/apache/mod_usertrack.so
%{_libdir}/apache/mod_version.so
%{_libdir}/apache/mod_vhost_alias.so
%{_libdir}/apache/httpd.exp

%dir /var/log/httpd

%dir %{_libdir}/apache
%dir %{_libdir}/apache-extramodules
%attr(0700,apache,root) %dir /var/cache/httpd
%exclude %{_mandir}/man8/htcacheclean.8*
%exclude %{_mandir}/man8/suexec.8*
%{_mandir}/*/*

%{_localstatedir}/lib/rpm/filetriggers/webapp.*
%{_localstatedir}/lib/rpm/filetriggers/httpd.filter
%attr(0755,root,root) %{_localstatedir}/lib/rpm/filetriggers/httpd.script

%files mod_proxy
%doc modules/proxy/CHANGES
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_proxy.conf
%{_libdir}/apache/mod_proxy_connect.so
%{_libdir}/apache/mod_proxy_ftp.so
%{_libdir}/apache/mod_proxy_http.so
%{_libdir}/apache/mod_proxy.so
%{_libdir}/apache/mod_proxy_balancer.so
%attr(0770,apache,root) %dir /var/cache/httpd/mod_proxy

%files mod_proxy_ajp
%doc modules/proxy/CHANGES
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_proxy_ajp.conf
%{_libdir}/apache/mod_proxy_ajp.so

%files mod_proxy_scgi
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_proxy_scgi.conf
%{_libdir}/apache/mod_proxy_scgi.so

%files mod_dav
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_dav.conf
%{_libdir}/apache/mod_dav_fs.so
%{_libdir}/apache/mod_dav_lock.so
%{_libdir}/apache/mod_dav.so
%attr(-,apache,apache) %dir /var/lib/dav
 
%files mod_ldap
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_ldap.conf
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_authnz_ldap.conf
%{_libdir}/apache/mod_ldap.so
%{_libdir}/apache/mod_authnz_ldap.so
%attr(0600,apache,root) %ghost /var/cache/httpd/mod_ldap_cache

%files mod_cache
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_cache.conf
%{_libdir}/apache/mod_cache.so

%files mod_disk_cache
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_disk_cache.conf
%{_libdir}/apache/mod_disk_cache.so

%files mod_mem_cache
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_mem_cache.conf
%{_libdir}/apache/mod_mem_cache.so

%files mod_file_cache
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_file_cache.conf
%{_libdir}/apache/mod_file_cache.so

%files mod_deflate
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_deflate.conf
%{_libdir}/apache/mod_deflate.so

%files mod_suexec
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_suexec.conf
%{_libdir}/apache/mod_suexec.so
%attr(4710,root,apache) %{_sbindir}/suexec
%{_mandir}/man8/suexec.8*

%files mod_userdir
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_userdir.conf
%{_libdir}/apache/mod_userdir.so

%files mod_ssl
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_ssl.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/vhosts.d/*_default_ssl_vhost.conf
%{_libdir}/apache/mod_ssl.so
%attr(0700,apache,root) %dir /var/cache/httpd/mod_ssl
%attr(0600,apache,root) %ghost /var/cache/httpd/mod_ssl/scache.dir
%attr(0600,apache,root) %ghost /var/cache/httpd/mod_ssl/scache.pag
%attr(0600,apache,root) %ghost /var/cache/httpd/mod_ssl/scache.sem

%files mod_dbd
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_dbd.conf
%{_libdir}/apache/mod_dbd.so

%files mod_authn_dbd
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_authn_dbd.conf
%{_libdir}/apache/mod_authn_dbd.so

%files mod_reqtimeout
%config(noreplace) %{_sysconfdir}/httpd/modules.d/*_mod_reqtimeout.conf
%{_libdir}/apache/mod_reqtimeout.so

%files htcacheclean
%{_initrddir}/htcacheclean
%config(noreplace) %{_sysconfdir}/sysconfig/htcacheclean
%{_sbindir}/htcacheclean
%{_mandir}/man8/htcacheclean.8*

%files devel
%multiarch %{multiarch_includedir}/apache/ap_config_layout.h
%{_includedir}/apache
%dir %{_libdir}/apache/build
%dir %{_sysconfdir}/httpd/build
%{_libdir}/apache/build/*.mk
%{_libdir}/apache/build/*.sh
%{_libdir}/apache/build/envvars
%{_sbindir}/envvars-std
%{_sbindir}/apxs

%files source
%{_usrsrc}/apache-%{version}

%files doc
%doc installed-manual/*
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf/webapps.d/00_manual.conf


%changelog
* Tue Jun 11 2013 oden <oden> 2.2.24-1.1.mga2
+ Revision: 441937
- P106: security fix for CVE-2013-1862 (upstream)
- P107: fix buffer overflow in htdigest (upstream)
- 2.2.24 (fixes CVE-2012-3499, CVE-2012-4558)

  + luigiwalser <luigiwalser>
    - 2.2.23 (fixes CVE-2012-0883 and CVE-2012-2687)
    - re-diff patches 10 and 15
    - fix suexec path
    - make suexec config work with systemd

* Sat Apr 28 2012 tmb <tmb> 2.2.22-11.mga2
+ Revision: 233587
- add back rpm-helper requires for htcacheclean

* Sat Apr 28 2012 tmb <tmb> 2.2.22-10.mga2
+ Revision: 233586
- Require rpm-helper >= 0.24.8-1 for systemd support

* Fri Apr 27 2012 tmb <tmb> 2.2.22-9.mga2
+ Revision: 233496
- rebuild for versioned rpm-helper requires

* Sat Apr 21 2012 luigiwalser <luigiwalser> 2.2.22-8.mga2
+ Revision: 232417
- add rpm-helper requirements for post_service scripts
- do not edit original service source file during build

* Sun Apr 08 2012 guillomovitch <guillomovitch> 2.2.22-7.mga2
+ Revision: 229775
- drop PrivateTmp from systemd service (fix #5143)

* Sun Apr 08 2012 luigiwalser <luigiwalser> 2.2.22-6.mga2
+ Revision: 229771
- merge apache-mod_suexec

* Mon Mar 19 2012 luigiwalser <luigiwalser> 2.2.22-5.mga2
+ Revision: 224024
- use arch independent libdir to find modules (thanks Funda Wang)

* Sun Mar 18 2012 luigiwalser <luigiwalser> 2.2.22-4.mga2
+ Revision: 223823
- use USR1 instead of HUP for systemctl reload (do not kill children)
- use package ordering to ensure _post_service is run at the right time
- do httpd restarts via posttrans and filetriggers (explained in spec)

  + colin <colin>
    - Fix systemd migration on upgrade (ensure mpm is installed and linked for apache post)
    - Fix all mpm systemd units (other than prefork)
    - Ensure only one mpm systemd unit can be enabled at any one time.

* Mon Mar 12 2012 guillomovitch <guillomovitch> 2.2.22-3.mga2
+ Revision: 222883
- deport base file and user creation in webserver-base package

  + luigiwalser <luigiwalser>
    - start httpd after remote-fs and named (from fedora)
    - enable PrivateTmp in service file (rh #781440)
    - update httpd.conf (from mdv)

* Sun Feb 12 2012 luigiwalser <luigiwalser> 2.2.22-2.mga2
+ Revision: 208280
- drop distcache support from mod_ssl
- build against current db version
- sync doc package with mdv
- update 01_default_ssl_vhost.conf and patch 0 (from mdv)
- minor requires fixes from mdv

* Tue Feb 07 2012 guillomovitch <guillomovitch> 2.2.22-1.mga2
+ Revision: 205893
- new version
- rediff ab patch
- drop security patches related to fixed vulns

* Thu Jan 19 2012 guillomovitch <guillomovitch> 2.2.21-9.mga2
+ Revision: 198442
- reduce multiple file copying
- ensure source and doc packages are noarch
- merge apache-doc package

* Thu Jan 19 2012 colin <colin> 2.2.21-8.mga2
+ Revision: 198013
- Fix systemd unit PID path (breaks with systemd v38)

* Sat Dec 31 2011 dmorgan <dmorgan> 2.2.21-7.mga2
+ Revision: 189170
- Add P21/22: Fix CVE2011-3368 and regression introduced in CVE 2011-3192
- Use systemd rpm macro

* Thu Oct 27 2011 nanardon <nanardon> 2.2.21-5.mga2
+ Revision: 158597
- apache-mpm-event provides apache-mpm not 'apache'

* Sat Oct 15 2011 dmorgan <dmorgan> 2.2.21-4.mga2
+ Revision: 155444
- Rebuild because it seems apache-mpm-event is missing, preventing libapreq2 to build

* Sun Sep 18 2011 pterjan <pterjan> 2.2.21-3.mga2
+ Revision: 145045
- Obsolete apache-base

* Wed Sep 14 2011 guillomovitch <guillomovitch> 2.2.21-2.mga2
+ Revision: 143581
- merge apache-base and apache-modules as apache package
- load modules inconditionaly
- drop useless dependencies from apache-devel package

* Wed Sep 14 2011 guillomovitch <guillomovitch> 2.2.21-1.mga2
+ Revision: 143348
- new version

* Thu Sep 08 2011 guillomovitch <guillomovitch> 2.2.20-3.mga2
+ Revision: 141320
- systemd support

* Thu Sep 01 2011 guillomovitch <guillomovitch> 2.2.20-2.mga2
+ Revision: 137745
- merge apache-conf and apache-base, to reduce dependencies hell
- rework dependencies to a comprehensive model: apache is an empty package, requiring the configuration, the modules and an engine
- rework post/preun scripts to use 'service httpd condrestart'
- ensure post/preun dependencies consistency with post/preun scriptlets
- simplify macros mess
- stop preventing initscript to be localized

* Thu Sep 01 2011 guillomovitch <guillomovitch> 2.2.20-1.mga2
+ Revision: 137516
- add missing LSB headers to htcacheclean init script
- new version
- drop suexec PATH patch
- rediff french documentation fixes, mpm-itk, mpm-peruser and authnoprov patches
- large spec cleanup

  + misc <misc>
    - remove README.urpmi, as it only speak of change dating back to 2008.1

  + pterjan <pterjan>
    - Revert re-import
    - imported package apache

* Fri Jan 14 2011 ahmad <ahmad> 2.2.17-4.mga1
+ Revision: 17736
- drop old/unneeded scriptlets
- imported package apache

